//
//  WordFinder.h
//  GNUstep Duncan
//
//  Created by Risa Mettaserikul on Fri Feb 07 2003.
//  Copyright (c) 2003 CSFSS. All rights reserved.
//
/* AppController */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#import "Duncan.h"


@interface DuncanDataRepresentation : NSObject
{
    id target;
    NSMutableArray *keywords;
    NSMutableArray *wordList;
}

- (NSArray*) wordList;
- (id) initWithKeyword:(NSString *)str wordList:(NSArray *)array;
@end


@interface AppController : NSObject
{

    IBOutlet NSButton *bookmarkButton;
    IBOutlet NSButton *deleteButton;
    IBOutlet NSTextView *displayView;
    IBOutlet NSButton *editButton;
    IBOutlet NSWindow *mainWindow;
    IBOutlet NSButton *searchButton;
    IBOutlet NSButton *backButton;
    IBOutlet NSButton *forwardButton;
    IBOutlet NSComboBox *wordField;
    IBOutlet NSBrowser *wordList;

    NSProgressIndicator *progressBar;
    int threadCount;
    
    NSMutableDictionary *currentWords; //Data centers (NSPort) are key.
    Duncan *duncan;    
}

- (void)controlTextDidEndEditing:(NSNotification *)aNotification;

- (IBAction)wordFieldEnd:(id)sender;
- (IBAction)browserChoose:(id)sender;
- (IBAction)forward:(id)sender;
- (IBAction)back:(id)sender;

@end
